module.exports = function(grunt) {
  grunt.initConfig({
    pkg: grunt.file.readJSON('package.json'),
    concat: {
      options: {
        separator: '',
      },
      dist: {
        src: ['ds.js','lib/_fl_127.js', 'lib/_fl_136.js','lib/_fl_129.js',
        'lib/_fl_130.js',
        'lib/_fl_128.js','lib/_fl_135.js',
        'lib/_fl_131.js','lib/_fl_133.js',
        'lib/_fl_132.js','lib/_fl_134.js','lib/_fl_137.js',
        'lib/CoreCrypto.js', 'lib/FStar_All.js',
        'lib/FStar_Array.js',
        'lib/FStar_Buffer.js',
        'lib/FStar_Char.js',
        'lib/FStar_Classical.js',
        'lib/FStar_CommonST.js',
        'lib/FStar_Heap.js',
        'lib/FStar_IO.js',
        'lib/FStar_Int32.js',
        'lib/FStar_Int8.js',
        'lib/FStar_Int_Cast.js',
        'lib/FStar_List_Tot.js',
        'lib/FStar_List_Tot_Base.js',
        'lib/FStar_List_Tot_Properties.js',
        'lib/FStar_ST.js',
        'lib/FStar_Seq.js',
        'lib/FStar_SeqProperties.js',
        'lib/FStar_Seq_Base.js',
        'lib/FStar_Seq_Properties.js',
        'lib/FStar_StrongExcludedMiddle.js',
        'lib/FStar_UInt.js',
        'lib/FStar_UInt32.js',
        'lib/FStar_UInt8.js'],
        dest: '<%= pkg.name %>.js',
      }
    },
    uglify: {
      options: {
        banner:'/* <%= pkg.name %> <%= grunt.template.today("yyyy-mm-dd") %> */\n'
      },
      build: {
        src: '<%= pkg.name %>.js',
        dest: '<%= pkg.name %>.min.js'
      }
    }
  });


  grunt.loadNpmTasks('grunt-contrib-concat');
  grunt.loadNpmTasks('grunt-contrib-uglify-es');

  grunt.registerTask('default', ['concat', 'uglify']);

  grunt.registerTask('test', 'log some stuff', function(){ grunt.log.write('Logging some stuff...').ok(); });

};
