
(function(ds){

    ds._o_058._O_045 = {
        _c_161: 0x00,
        _c_162: 0x40,
        _c_163: 0x80,
        _c_164: 0xC0
    };

    ds._o_058._O_046 = {
        _c_165:          0,
        _c_166:          1,
        _c_167:          2,
        _c_168:          3,
        _c_169:          4,
        _c_170:          5,
        _c_171:          6,
        _c_172:          7,
        _c_173:          8,
        _c_174:          9,
        _c_175:         10,
        _c_176:         11,
        _c_177:         12,
        _c_178:         13,
        _c_179:         16,
        _c_180:         17,
        _c_181:         19,
        _c_182:         22,
        _c_183:         23,
        _c_184:         24,
        _c_185:         30
    };

    ds._o_058._f_300 = (tagClass, type, constructed, value, options) => {
        let obj = {
            tagClass: tagClass,
            type: type,
            constructed: constructed,
            composed: constructed || ds._o_050._f_144(value),
            value: value
        };
        return obj;
    };

    ds._o_058._f_301 = (obj, options) => {
        let copy;

        if(ds._o_050._f_144(obj)) {
            copy = [];
            for(let i = 0; i < obj.length; ++i) {
                copy.push(asn1.copy(obj[i], options));
            }
            return copy;
        }

        if(typeof obj === 'string') {
            return obj;
        }

        copy = {
            tagClass: obj.tagClass,
            type: obj.type,
            constructed: obj.constructed,
            composed: obj.composed,
            value: asn1.copy(obj.value, options)
        };
        if(options && !options.excludeBitStringContents) {
            copy.bitStringContents = obj.bitStringContents;
        }
        return copy;
    };

    const _f_306 = (bytes, remaining, n) => {
        if(n > remaining) {
            let error = new Error('Too few bytes to parse DER.');
            error.available = bytes.length();
            error.remaining = remaining;
            error.requested = n;
            throw error;
        }
    }

    const _c_160 = (bytes, remaining) => {
        let b2 = bytes._f_131();
        remaining--;
        if(b2 === 0x80) {
            return undefined;
        }

        let length;
        const longForm = b2 & 0x80;
        if(!longForm) {
            length = b2;
        } else {
            let longFormBytes = b2 & 0x7F;
            _f_306(bytes, remaining, longFormBytes);
            length = bytes.getInt(longFormBytes << 3);
        }
        if(length < 0) {
            throw new Error('Negative length: ' + length);
        }
        return length;
    };

    const _f_307 = (bytes, remaining, depth, options) => {
        let start;

        _f_306(bytes, remaining, 2);

        const b1 = bytes._f_131();
        remaining--;

        let tagClass = (b1 & 0xC0);
        let type = b1 & 0x1F;

        start = bytes.length();
        let length = _c_160(bytes, remaining);
        remaining -= start - bytes.length();

        if(length !== undefined && length > remaining) {
            if(options.strict) {
                let error = new Error('Too few bytes to read ASN.1 value.');
                error.available = bytes.length();
                error.remaining = remaining;
                error.requested = length;
                throw error;
            }
            length = remaining;
        }

        let value;
        let bitStringContents;
        let constructed = ((b1 & 0x20) === 0x20);

        if(constructed) {
            value = [];
            if(length === undefined) {
                for(;;) {
                    _f_306(bytes, remaining, 2);
                    if(bytes.bytes(2) === String.fromCharCode(0, 0)) {
                        bytes.getBytes(2);
                        remaining -= 2;
                        break;
                    }
                    start = bytes.length();
                    value.push(_f_307(bytes, remaining, depth + 1, options));
                    remaining -= start - bytes.length();
                }
            } else {
                while(length > 0) {
                    start = bytes.length();
                    value.push(_f_307(bytes, length, depth + 1, options));
                    remaining -= start - bytes.length();
                    length -= start - bytes.length();
                }
            }
        }

        if(value === undefined && tagClass === ds._o_058._O_045._c_161 &&
            type === ds._o_058._O_046._c_168) {
            bitStringContents = bytes.bytes(length);
        }

        if(value === undefined && options.decodeBitStrings &&
            tagClass === ds._o_058._O_045._c_161 &&
            (type === ds._o_058._O_046._c_168 ) &&
            length > 1) {
            const savedRead = bytes.read;
            const savedRemaining = remaining;
            let unused = 0;
            if(type === ds._o_058._O_046._c_168) {
                _f_306(bytes, remaining, 1);
                unused = bytes._f_131();
                remaining--;
            }

            if(unused === 0) {
                try {
                    start = bytes.length();
                    let subOptions = {
                        verbose: options.verbose,
                        strict: true,
                        decodeBitStrings: true
                    };
                    let composed = _f_307(bytes, remaining, depth + 1, subOptions);
                    let used = start - bytes.length();
                    remaining -= used;
                    if(type == ds._o_058._O_046._c_168) {
                        used++;
                    }

                    const tc = composed.tagClass;
                    if(used === length &&
                        (tc === ds._o_058._O_045._c_161 || tc === ds._o_058._O_045._c_163)) {
                        value = [composed];
                    }
                } catch(ex) {
                }
            }
            if(value === undefined) {
                bytes.read = savedRead;
                remaining = savedRemaining;
            }
        }

        if(value === undefined) {
            if(length === undefined) {
                if(options.strict) {
                    throw new Error('Non-constructed ASN.1 object of indefinite length.');
                }
                length = remaining;
            }

            if(type === ds._o_058._O_046._c_185) {
                value = '';
                for(; length > 0; length -= 2) {
                    _f_306(bytes, remaining, 2);
                    value += String.fromCharCode(bytes.getInt16());
                    remaining -= 2;
                }
            } else {
                value = bytes.getBytes(length);
            }
        }

        let asn1Options = bitStringContents === undefined ?  null : {
            bitStringContents: bitStringContents
        };

        return ds._o_058._f_300(tagClass, type, constructed, value, asn1Options);
    }

    ds._o_058._f_302 = (obj) => {
        let bytes = ds._o_059._f_125();
        let b1 = obj.tagClass | obj.type;
        let value = ds._o_059._f_125();
        let useBitStringContents = false;

        if('bitStringContents' in obj) {
            useBitStringContents = true;
            if(obj.original) {
                useBitStringContents = ds._o_058._f_304(obj, obj.original);
            }
        }

        if(useBitStringContents) {
            value._f_127(obj.bitStringContents);
        } else if(obj.composed) {
            if(obj.constructed) {
                b1 |= 0x20;
            } else {
                value._f_128(0x00);
            }

            for(let i = 0; i < obj.value.length; ++i) {
                if(obj.value[i] !== undefined) {
                    value._f_136(ds._o_058._f_302(obj.value[i]));
                }
            }
        } else {
            if(obj.type === ds._o_058._O_046._c_185) {
                for(let i = 0; i < obj.value.length; ++i) {
                    value._f_135(obj.value.charCodeAt(i));
                }
            } else {
                if(obj.type === ds._o_058._O_046._c_167 &&
                    obj.value.length > 1 &&
                    ((obj.value.charCodeAt(0) === 0 &&
                        (obj.value.charCodeAt(1) & 0x80) === 0) ||
                        // leading 0xFF for negative integer
                        (obj.value.charCodeAt(0) === 0xFF &&
                            (obj.value.charCodeAt(1) & 0x80) === 0x80))) {
                    value._f_127(obj.value.substr(1));
                } else {
                    value._f_127(obj.value);
                }
            }
        }

        bytes._f_128(b1);
        if(value.length() <= 127) {
            bytes._f_128(value.length() & 0x7F);
        } else {
            let len = value.length();
            let lenBytes = '';
            do {
                lenBytes += String.fromCharCode(len & 0xFF);
                len = len >>> 8;
            } while(len > 0);

            bytes._f_128(lenBytes.length | 0x80);

            for(let i = lenBytes.length - 1; i >= 0; --i) {
                bytes._f_128(lenBytes.charCodeAt(i));
            }
        }

        bytes._f_136(value);
        return bytes;
    };

    ds._o_058._f_303 = (oid) => {
        let values = oid.split('.');
        let bytes = ds._o_059._f_125();
        bytes._f_128(40 * parseInt(values[0], 10) + parseInt(values[1], 10));
        let last, valueBytes, value, b;
        for(let i = 2; i < values.length; ++i) {
            last = true;
            valueBytes = [];
            value = parseInt(values[i], 10);
            do {
                b = value & 0x7F;
                value = value >>> 7;
                if(!last) {
                    b |= 0x80;
                }
                valueBytes.push(b);
                last = false;
            } while(value > 0);

            for(let n = valueBytes.length - 1; n >= 0; --n) {
                bytes._f_128(valueBytes[n]);
            }
        }
        return bytes;
    };

    ds._o_058._f_304 = (obj1, obj2, options) => {
        if(ds._o_050._f_144(obj1)) {
            if(!ds._o_050._f_144(obj2)) {
                return false;
            }
            if(obj1.length !== obj2.length) {
                return false;
            }
            for(let i = 0; i < obj1.length; ++i) {
                if(!ds._o_058._f_304(obj1[i], obj2[i])) {
                    return false;
                }
                return true;
            }
        }

        if(typeof obj1 !== typeof obj2) {
            return false;
        }

        if(typeof obj1 === 'string') {
            return obj1 === obj2;
        }

        let equal = obj1.tagClass === obj2.tagClass &&
            obj1.type === obj2.type &&
            obj1.constructed === obj2.constructed &&
            obj1.composed === obj2.composed &&
            ds._o_058._f_304(obj1.value, obj2.value);
        if(options && options.includeBitStringContents) {
            equal = equal && (obj1.bitStringContents === obj2.bitStringContents);
        }

        return equal;
    };

    ds._o_058._f_305 = (bytes, options) => {
        if(options === undefined) {
            options = {
                strict: true,
                decodeBitStrings: true
            };
        }
        if(typeof options === 'boolean') {
            options = {
                strict: options,
                decodeBitStrings: true
            };
        }
        if(!('strict' in options)) {
            options.strict = true;
        }
        if(!('decodeBitStrings' in options)) {
            options.decodeBitStrings = true;
        }

        if(typeof bytes === 'string') {
            bytes = ds._o_059._f_125(bytes);
        }

        return _f_307(bytes, bytes.length(), 0, options);
    }

})(ds);