
/** main */
(function(ds){

    ds._o_054.sign = (key, md, scheme) => {
        /*Sign */
        //console.info('**********************FFFFF inicio function sign ds, scheme: ' + JSON.stringify(scheme));
        let bt = false;
        if(typeof scheme === 'string') {
            scheme = scheme.toUpperCase();
        }
        if(scheme === undefined || scheme === 'RSASSA-PKCS1-V1_5') {
            scheme = { encode: ds._o_051._f_151 };
            bt = 0x01;
        } else if(scheme === 'NONE' || scheme === 'NULL' || scheme === null) {
            scheme = { encode: function() { return md; } };
            bt = 0x01;
        }
        let d = scheme.encode(md, key.n.bitLength());
        return ds._o_051._f_153(d, key, bt);

    };

    ds._o_054.verify =  (key, digest, signature, scheme) => {
        //console.info('********************** inicio function verify ds, scheme: ' + JSON.stringify(scheme));
        if(typeof scheme === 'string') {
            scheme = scheme.toUpperCase();
        } else if(scheme === undefined) {
            scheme = 'RSASSA-PKCS1-V1_5';
        }

        if(scheme === 'RSASSA-PKCS1-V1_5') {
            scheme = {
                verify: function(digest, d) {
                    d = ds._o_051._f_152(d, key, true);
                    let obj = ds._o_058._f_305(d);
                    return digest === obj.value[1].value;
                }
            };
        } else if(scheme === 'NONE' || scheme === 'NULL' || scheme === null) {
            scheme = {
                verify: function(digest, d) {
                    d = ds._o_051._f_152(d, key, true);
                    return digest === d;
                }
            };
        }

        let d = ds._o_051._f_154(signature, key, true, false);
        return scheme.verify(digest, d, key.n.bitLength());

    };


})(ds);